/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.enums.YYLoggerTuJingEnum
 *  fire.pb.item.AddItemResult
 *  fire.pb.item.ItemBase
 *  fire.pb.item.ItemHelper
 *  fire.pb.item.Pack
 *  fire.pb.main.ConfigManager
 *  fire.pb.talk.MessageMgr
 *  mkdb.Lockeys
 *  mkdb.Procedure
 *  mkdb.TTable
 *  mkio.Protocol
 *  xtable.Locks
 *  xtable.Properties
 */
package fire.pb.friends;

import fire.log.enums.YYLoggerTuJingEnum;
import fire.pb.friends.FriendGiveItem;
import fire.pb.friends.FriendGiveProxy;
import fire.pb.friends.Module;
import fire.pb.friends.SGiveItem;
import fire.pb.item.AddItemResult;
import fire.pb.item.ItemBase;
import fire.pb.item.ItemHelper;
import fire.pb.item.Pack;
import fire.pb.main.ConfigManager;
import fire.pb.talk.MessageMgr;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;
import mkdb.Lockeys;
import mkdb.Procedure;
import mkdb.TTable;
import mkio.Protocol;
import xtable.Locks;
import xtable.Properties;

public class PGiveItem
extends Procedure {
    private final long roleId;
    private final long targetRoleId;
    private final Map<Integer, Integer> itemMap;

    public PGiveItem(long roleId, long targetRoleId, Map<Integer, Integer> itemMap) {
        this.roleId = roleId;
        this.targetRoleId = targetRoleId;
        this.itemMap = itemMap;
    }

    protected boolean process() {
        ItemBase bi;
        int itemNum;
        int itemKey;
        if (this.itemMap.isEmpty()) {
            return false;
        }
        ArrayList<Long> roleIds = new ArrayList<Long>();
        roleIds.add(this.roleId);
        roleIds.add(this.targetRoleId);
        this.lock(Lockeys.get((TTable)Locks.ROLELOCK, roleIds));
        FriendGiveProxy friendGiveProxy = FriendGiveProxy.getFriendGiveProxy(this.roleId, false);
        if (friendGiveProxy == null) {
            return false;
        }
        int giveNum = friendGiveProxy.getGiveNum(this.targetRoleId);
        int addGiveNum = 0;
        for (int itemNum2 : this.itemMap.values()) {
            addGiveNum += itemNum2;
        }
        if (giveNum + addGiveNum > FriendGiveProxy.getDayGiveMax()) {
            return false;
        }
        ArrayList<ItemBase> giveItems = new ArrayList<ItemBase>();
        Pack selfBag = new Pack(this.roleId, false);
        for (Map.Entry<Integer, Integer> e : this.itemMap.entrySet()) {
            itemKey = e.getKey();
            itemNum = e.getValue();
            bi = selfBag.getItem(itemKey);
            if (bi == null) {
                return false;
            }
            if (itemNum <= 0) {
                return false;
            }
            if (bi.getNumber() < itemNum) {
                return false;
            }
            if (PGiveItem.isCanGiveByItemId(bi.getItemId())) continue;
            return false;
        }
        for (Map.Entry<Integer, Integer> e : this.itemMap.entrySet()) {
            itemKey = e.getKey();
            bi = selfBag.TransOut(itemKey, itemNum = e.getValue().intValue(), "Friend give item cost");
            if (bi == null) {
                return false;
            }
            giveItems.add(bi);
        }
        Pack targetBag = new Pack(this.targetRoleId, false);
        for (ItemBase item : giveItems) {
            if (item.isBind() || item.isTimeout()) {
                MessageMgr.psendMsgNotifyWhileRollback((long)this.roleId, (int)141488, null);
                return false;
            }
            ItemHelper.setOwnerid((ItemBase)item, (long)0L);
            item.bind();
            int itemId = item.getItemId();
            AddItemResult result = targetBag.doAddItem(item, -1, "Friend give item add", YYLoggerTuJingEnum.tujing_Value_friendgiveget, itemId);
            if (result != AddItemResult.SUCC) {
                if (result == AddItemResult.FULL) {
                    MessageMgr.psendMsgNotifyWhileRollback((long)this.roleId, (int)162164, null);
                } else {
                    MessageMgr.psendMsgNotifyWhileRollback((long)this.roleId, (int)141488, null);
                }
                SGiveItem send = new SGiveItem();
                send.roleid = this.targetRoleId;
                send.itemnum = (byte)friendGiveProxy.getGiveNum(this.targetRoleId);
                PGiveItem.psendWhileRollback((long)this.roleId, (Protocol)send);
                return false;
            }
            String roleName = Properties.selectRolename((Long)this.roleId);
            String itemName = item.getName();
            MessageMgr.psendMsgNotifyWhileCommit((long)this.targetRoleId, (int)180028, (List)MessageMgr.getStringList((Object[])new Object[]{roleName, item.getNumber(), itemName}));
        }
        if (giveItems.size() != this.itemMap.size()) {
            return false;
        }
        friendGiveProxy.addGiveNum(this.targetRoleId, addGiveNum);
        SGiveItem send = new SGiveItem();
        send.roleid = this.targetRoleId;
        send.itemnum = (byte)friendGiveProxy.getGiveNum(this.targetRoleId);
        PGiveItem.psendWhileCommit((long)this.roleId, (Protocol)send);
        MessageMgr.psendMsgNotifyWhileCommit((long)this.roleId, (int)180014, null);
        if (Module.logger.isInfoEnabled()) {
            ArrayList<Integer> itemIds = new ArrayList<Integer>(giveItems.size());
            ArrayList<Integer> itemNums = new ArrayList<Integer>(giveItems.size());
            ArrayList<String> itemNames = new ArrayList<String>(giveItems.size());
            for (ItemBase item : giveItems) {
                itemIds.add(item.getItemId());
                itemNums.add(item.getNumber());
                itemNames.add(item.getName());
            }
            Module.logger.info((Object)("[PGiveItem] roleId:" + this.roleId + " targetRoleId:" + this.targetRoleId + " itemIds:" + Arrays.toString(itemIds.toArray()) + " itemNums:" + Arrays.toString(itemNums.toArray()) + " itemNames:" + Arrays.toString(itemNames.toArray())));
        }
        return true;
    }

    public static boolean isCanGiveByItemId(int itemId) {
        TreeMap confs = ConfigManager.getInstance().getConf(FriendGiveItem.class);
        return confs.get(itemId) != null;
    }
}

